#This patch is all about surviving as long as you can in a battle mode while killing the cpus as many times as possible

import mk64_lib
import sys

#Read in command line arguments
input_file = '../Unaltered_Roms/Mario Kart 64.z64'
output_file = 'MK64_hot_potato_battle.z64'

#Load rom
mk64rom = mk64_lib.rom(input_file)

#To do
#-Default to 1 hp
#-Get rid of HP text if only 1 HP
#-Try lowering probability of defensive weapons vs. offensive weapons (make stars and ghosts rarer)
#-Make bigger maps fast paced?


#Memory map
#0x80102000 - 1 byte - Max HP
#0x80102001 - 1 byte - P1 HP
#0x80102002 - 1 byte - P2 HP
#0x80102003 - 1 byte - P3 HP
#0x80102004 - 1 byte - P4 HP
#0x80102100 - 1 byte - Who is the hot potato
#0x80102104 - 2 bytes - Timer
#0x80102108 - 2 bytes - Timer default
#0x8010210C - 1 byte - Title Menu y-axis Selection (0, 1, 2, ect. as you go down the menu)
#0x8010210D - 1 byte - Title menu y-axis movement in progress? (0 = no, 1 = yes)
#0x8010210E - 1 byte - Title menu x-axis movement in progress? (0 = no, 1 = left, 2=right, 4=done)
#0x8010210F - 1 byte - Disable star items?  (1=stars are disabled, 0 = stars are enabled)
#0x80102110 - 1 byte - Disable ghost items?  (1=ghosts are disabled, 0 = ghosts are enabled)
#0x80102111 - 1 byte - Widescreen (0=OFF, 1=ON)
#0x80102112 - 1 byte - Antialiasing (0=OFF, 1=ON)
#0x80102113 - 1 byte - Music in 3 & 4 Player mode (0=OFF, 1=ON)
#0x80102114 - 1 byte - Multiple players can select same character (0=OFF, 1=ON)
#0x80102115 - 1 byte - Infinite green shells (0=OFF, 1=ON)
#0x80102116 - 1 byte - Flat courses (0=OFF, 1=ON)
#0x80102117 - 1 byte - Automatic Items (0=OFF, 1=ON)




#codeblock_addr = 0xE9E80 #Somewhere in PAL VI code that goes unused in NTSC (seems to be the best so far, use this so I can use the debugger code)
#codeblock_addr = 0x121f4 #Path following function which gives us plenty of space to overwrite
codeblock_addr = 0x120f4

#Hook into boot
code = ['j ' + hex(codeblock_addr+mk64rom.rom_to_ram), 'nop']
mk64rom.insert_code(0x17EC, code)


#Store acsii text in rom
text_address = 0x800EB800 + mk64rom.ram_to_rom
text_code = [0x434F554E, 0x54444F57, 0x4E202020, 0x20202000]
mk64rom.insert_code(text_address + 0x00, text_code)  #Set text "COUNTDOWN" + spaces
text_code = [0x48500000]
mk64rom.insert_code(text_address + 0x10, text_code)  #Set text "HP"
text_code = [0x434F554E, 0x54444F57, 0x4E000000] 
mk64rom.insert_code(text_address + 0x14, text_code) #Set text "COUNTDOWN" with no spaces
text_code = [0x3D3D3D00]
mk64rom.insert_code(text_address + 0x20, text_code) #set text for "==="
text_code = [0x53544152, 0x20495445, 0x4D530000]
mk64rom.insert_code(text_address + 0x24, text_code) #Set text for "STAR ITEMS"
text_code = [0x47484F53, 0x54204954, 0x454D5300]
mk64rom.insert_code(text_address + 0x30, text_code)
text_code = [0x4F464600] 
mk64rom.insert_code(text_address + 0x40, text_code) #Set text for "OFF"
text_code = [0x4F4E0000]
mk64rom.insert_code(text_address + 0x44, text_code) #Set text for "ON"
text_code = [0x484F5420, 0x504F5441, 0x544F2042, 0x4154544C, 0x45007631, 0x2E312042, 0x59205452, 0x49434C4F, 0x4E000000]
mk64rom.insert_code(text_address + 0x48, text_code) #Set text for "HOT POTATO BATTLE v1.0 BY TRICLON"
text_code = [0x57494445, 0x53435245, 0x454E0000]
mk64rom.insert_code(text_address + 0x6C, text_code) #Set text for "WIDESCREEN"
text_code = [0x44495341, 0x424C4520, 0x41410000, 0x00000000]
mk64rom.insert_code(text_address + 0x78, text_code) #Set text for "DISABLE AA"
text_code = [0x33502F34, 0x50204D55, 0x53494300]
mk64rom.insert_code(text_address + 0x88, text_code) #Set text for "3P/4P MUSIC"
text_code = [0x53414D45, 0x20434841, 0x52530000]
mk64rom.insert_code(text_address + 0x94, text_code) #Set text for "SAME CHARS"
text_code = [0x494E462E, 0x472E5348, 0x454C4C53, 0x00000000]
mk64rom.insert_code(text_address + 0xA4, text_code) #Set text for "INF. G. SHELLS"
text_code = [0x464C4154, 0x20434F55, 0x52534553, 0x00000000]
mk64rom.insert_code(text_address + 0xB4, text_code) #Set text for "FLAT COURSES"
text_code = [0x4155544F, 0x2D495445, 0x4D530000]
mk64rom.insert_code(text_address + 0xC4, text_code) #Set text for "AUTO-ITEMS"



#Insert code that runs at boot and initializes values for everything
boot_code = [
	'addiu $SP $SP 0xFFE8', #Store registers
	'SW $A0 0x0000 $SP',
	'SW $A1 0x0004 $SP',
	'SW $A2 0x0008 $SP',

	'lui $A0 0x8010', #Set default max HP
	'ori $A1 $zero 0x2',
	'sb $A1 0x2000 $A0',

	'lui $A0 0x8010', #Set default timer (0xE10 is 1 minute, 0x708 is 30 seconds)
	'ori $A1 $zero 0x708',
	'sh $A1 0x2108 $A0',

	#'ori $A1 $zero 0x0', #Set default star and ghost items to be off
	'nor $A1 $zero $zero',
	'sb $A1 0x210F $A0',
	'sb $A1 0x2110 $A0',

	#Set default game settings
	'sb $zero 0x2111 $A0', #Widescreen default = 0 (off)
	#'nor $A2 $zero $zero', #Sets boolean to compare to ON
	'sb $zero 0x2112 $A0', #disable antialising default = 0 (0ff)
	'sb $zero 0x2113 $A0', #3P/4P music default = 0 (off)
	'sb $zero 0x2114 $A0', #Select same chars = 0 (off)
	'sb $zero 0x2115 $A0', #Inf. green shells = 0 (off)



	'addiu $SP $SP 0x18', #Load registers
	'LW $A0 0x0000 $sp',
	'LW $A1 0x0004 $sp',
	'LW $A2 0x0008 $sp',


    'LUI $T6 0x8030', #Run these two lines the hook replaced
    'j 0x80000BF4', #Jump back to boot code after hook
    'LUI $AT 0x1FFF',
]
mk64rom.insert_code(codeblock_addr, boot_code) #Insert code that runs at boot into the debugger


codeblock_addr = codeblock_addr + len(boot_code)*4 + 16








#Load endlessly looping codeblock (aka The Engine
codeblock = [
	#Force always battle mode to avoid crashes
	'ori $K1 $zero 0x3',
	'lui $K0 0x800E',
	'sh $K1 0xC53E $K0',


	 #Check P1's balloon count, if player has two balloons, they are now the hot potato
	'ori $k1 $zero 0x0001', #Load 2 balloons into $k1 for comparison
	'lui $k0 0x8019',
	'lh $k0 0xD8C0 $k0', 
	'bne $k0 $k1 0x06', #If ballons == 2, run the following code
	'lui $k1 0x8019',
	'ori $k0 $zero 0x0002', #Set balloons back to 3
	'sh $k0 0xD8C0 $k1',
	'ori $k0 $zero 0x01', #Set P2 to be the hot potato (stored in RAM at 0x80102100)
	'lui $k1 0x8010',
	'sb $k0 0x2100 $k1',
	#Check P2's balloon count, if player has two balloons, they are now the hot potato
	'ori $k1 $zero 0x0001', #Load 2 balloons into $k1 for comparison
	'lui $k0 0x8019',
	'lh $k0 0xD8C2 $k0',  
	'bne $k0 $k1 0x06', #If ballons == 2, run the following code
	'lui $k1 0x8019',
	'ori $k0 $zero 0x0002', #Set balloons back to 3
	'sh $k0 0xD8C2 $k1',
	'ori $k0 $zero 0x02', #Set P2 to be the hot potato (stored in RAM at 0x80102100)
	'lui $k1 0x8010', 
	'sb $k0 0x2100 $k1',
	#Check P3's balloon count, if player has two balloons, they are now the hot potato
	'ori $k1 $zero 0x0001', #Load 2 balloons into $k1 for comparison
	'lui $k0 0x8019',
	'lh $k0 0xD8C4 $k0',  
	'bne $k0 $k1 0x06', #If ballons == 2, run the following code
	'lui $k1 0x8019',
	'ori $k0 $zero 0x0002', #Set balloons back to 3
	'sh $k0 0xD8C4 $k1',
	'ori $k0 $zero 0x03', #Set P3 to be the hot potato (stored in RAM at 0x80102100)
	'lui $k1 0x8010', 
	'sb $k0 0x2100 $k1',
	#Check P4's balloon count, if player has two balloons, they are now the hot potato
	'ori $k1 $zero 0x0001', #Load 2 balloons into $k1 for comparison
	'lui $k0 0x8019',
	'lh $k0 0xD8C6 $k0',  
	'bne $k0 $k1 0x06', #If ballons == 2, run the following code
	'lui $k1 0x8019',
	'ori $k0 $zero 0x0002', #Set balloons back to 3
	'sh $k0 0xD8C6 $k1',
	'ori $k0 $zero 0x04', #Set P3 to be the hot potato (stored in RAM at 0x80102100)
	'lui $k1 0x8010', 
	'sb $k0 0x2100 $k1',
	#First turn off smoke for all players so that if a player is no longer the hot potato, the smoke will stop
	'lui $k0 0x800F',	
	'sb $zero 0x6A5A $k0',
	'sb $zero 0x7832 $k0',
	'lui $k0 0x8010',
	'sb $zero 0x860A $k0',
	'sb $zero 0x93E2 $k0',
	#Make whoever is the hot potato smoke
	'lui $k0 0x8010', #P1
	'lbu $k0 0x2100 $k0',
	'ori $k1 $zero 0x01', 
	'bne $k0 $k1 0x03',
	'ori $k1 $zero 0x10',
	'lui $k0 0x800F',	
	'sb $k1 0x6A5A $k0',
	'lui $k0 0x8010', #P2
	'lbu $k0 0x2100 $k0',
	'ori $k1 $zero 0x02', 
	'bne $k0 $k1 0x03',
	'ori $k1 $zero 0x10',
	'lui $k0 0x800F',	
	'sb $k1 0x7832 $k0',
	'lui $k0 0x8010', #P3
	'lbu $k0 0x2100 $k0',
	'ori $k1 $zero 0x03', 
	'bne $k0 $k1 0x03',
	'ori $k1 $zero 0x10',
	'lui $k0 0x8010',	
	'sb $k1 0x860A $k0',
	'lui $k0 0x8010', #P4
	'lbu $k0 0x2100 $k0',
	'ori $k1 $zero 0x04', 
	'bne $k0 $k1 0x03',
	'ori $k1 $zero 0x10',
	'lui $k0 0x8010',	
	'sb $k1 0x93E2 $k0',
	#If timer less than zero, kill whoever is the hot potato and then reset the timer (note this sets the balloons to 0 and turns a person invisible/into a bomb)
	'lui $k1 0x8010',
	'lh $k1 0x2104 $k1',
	'slt $k1 $k1 $zero',
	'beq $k1 $zero 0x58', #If  custom timer is less than zero...

	'lui $k0 0x8010', #Subtract 1 HP from P1 if they are the hot potato
	'lbu $k0 0x2100 $k0',
	'ori $k1 $zero 0x01', 
	'bne $k0 $k1 0x11',
	'ori $k0 $zero 0x40',
	'lui $k1 0x800F',
	'sb $k0 0x6A4C $k1',
	'lui $k0 0x8010',
	'lbu $k1 0x2001 $k0',
	'addi $k1 $k1 0xFFFF',
	'sb $k1 0x2001 $k0',
	'bne $k1 $zero 0x9', #kill P1 if their HP = 0
	'ori $k0 $zero 0xFFFF',
	'lui $k1 0x8019',
	'sh $k0 0xD8C0 $k1',
	'ori $K0 $zero 0x04',
	'lui $k1 0x800F',
	'sb $K0 0x699C $k1',
	'ori $k0 $zero 0x40',
	'lui $k1 0x800F',
	'sb $k0 0x699D $k1',
	'lui $k0 0x8010', #Subtract 1 HP from P2 if they are the hot potato
	'lbu $k0 0x2100 $k0',
	'ori $k1 $zero 0x02', 
	'bne $k0 $k1 0x11',
	'ori $k0 $zero 0x40',
	'lui $k1 0x800F',
	'sb $k0 0x7824 $k1',
	'lui $k0 0x8010',
	'lbu $k1 0x2002 $k0',
	'addi $k1 $k1 0xFFFF',
	'sb $k1 0x2002 $k0',
	'bne $k1 $zero 0x9', #kill P2 if their HP = 0
	'ori $k0 $zero 0xFFFF',
	'lui $k1 0x8019',
	'sh $k0 0xD8C2 $k1',
	'ori $K0 $zero 0x04',
	'lui $k1 0x800F',
	'sb $K0 0x7774 $k1',
	'ori $k0 $zero 0x40',
	'lui $k1 0x800F',
	'sb $k0 0x7775 $k1',
	'lui $k0 0x8010', #Subtract 1 HP from P3 if they are the hot potato, kill P3 if their HP = 0
	'lbu $k0 0x2100 $k0',
	'ori $k1 $zero 0x03', 
	'bne $k0 $k1 0x11',
	'ori $k0 $zero 0x40',
	'lui $k1 0x8010',
	'sb $k0 0x85FC $k1',
	'lui $k0 0x8010',
	'lbu $k1 0x2003 $k0',
	'addi $k1 $k1 0xFFFF',
	'sb $k1 0x2003 $k0',
	'bne $k1 $zero 0x9', #kill P3 if their HP = 0
	'ori $k0 $zero 0xFFFF',
	'lui $k1 0x8019',
	'sh $k0 0xD8C4 $k1',
	'ori $K0 $zero 0x04',
	'lui $k1 0x8010',
	'sb $K0 0x854C $k1',
	'ori $k0 $zero 0x40',
	'lui $k1 0x8010',
	'sb $k0 0x854D $k1',
	'lui $k0 0x8010', #Subtract 1 HP from P4 if they are the hot potato, kill P4 if their HP = 0
	'lbu $k0 0x2100 $k0',
	'ori $k1 $zero 0x04', 
	'bne $k0 $k1 0x11',
	'ori $k0 $zero 0x40',
	'lui $k1 0x8010',
	'sb $k0 0x93D4 $k1',
	'lui $k0 0x8010',
	'lbu $k1 0x2004 $k0',
	'addi $k1 $k1 0xFFFF',
	'sb $k1 0x2004 $k0',
	'bne $k1 $zero 0x9', #kill P4 if their HP = 0
	'ori $k0 $zero 0xFFFF',
	'lui $k1 0x8019',
	'sh $k0 0xD8C6 $k1',
	'ori $K0 $zero 0x04',
	'lui $k1 0x8010',
	'sb $K0 0x9324 $k1',
	'ori $k0 $zero 0x40',
	'lui $k1 0x8010',
	'sb $k0 0x9325 $k1',
	'lui $k0 0x8010', #Set who his hot back to nothing
	'sb $zero 0x2100 $k0',
	'lh $k1 0x2108 $k0', #Reset timer to default value
	'sh $k1 0x2104 $k0',

	#Set widescreen mode if it is on
	'lui $K0 0x8010',
	'lb $K1 0x2111 $K0',
	'beq $K1 $zero 0xB', #If widescreen is on...
	'lui $K0 0x800E',
	'lb $K1 0xC533 $K0', #Load number of players
	'ori $K0 $zero 0x1',
	'bne $K1 $K0 0x4', #Run code for if player count is 2
	'lui $K0 0x8015',
	'ori $K1 $zero 0x4060',
	'sh $K1 0x0148 $K0',
	'beq $zero $zero 0x3', 
	'lui $K0 0x8015', #Run this code if players are 1P, 3P or 4P
	'ori $K1 $zero 0x3FDF',
	'sh $K1 0x0148 $K0',


	#Disable anti-aliasing if set to on
	#0x80102112 - 1 byte - Disable AA (0=OFF, 1=ON)
	'lui $k0 0x8010',
	'lb $k0 0x2112 $k0',
	'beq $k0 $zero 0x4', #If disable AA set to on
	'ori $K0 $zero 0x3216', #Disable anti-aliasing
	'lui $K1 0x800F',
	'sw $k0 0xB3DC $k1',
	'sw $K0 0xB40C $k1',

	#Add same character selection if set to on
	'lui $k0 0x8010',
	'lb $k0 0x2114 $k0',
	'beq $k0 $zero 0x8', #If set to on
	'lui $k0 0x800B',
	'ori $k1 $zero 0x7FFF',
	'sw $zero 0x3924 $k0',
	'sh $k1 0x3936 $k0',
	'sw $zero 0x39A4 $k0',
	'sh $k1 0x39B6 $k0',
	'sw $zero 0x3A38 $k0',
	'sh $k1 0x3A4E $k0',

	#Infinite green shells if set to on
	'lui $k0 0x8010',
	'lb $k0 0x2115 $k0',
	'beq $k0 $zero 0x1B', #If set to on
	'lui $k0 0x8016',
	'sb $zero 0xF6FF $k0', #Allow players to fire infinite green shells
	'ori $k1 $zero 0x3', #Give all players green shell items that are always on
	'sb $k1 0x5F5D $k0',
	'sb $k1 0x5F8A $k0',
	'sb $k1 0x603D $k0',
	'sb $k1 0x606A $k0',
	'sb $k1 0x611D $k0',
	'sb $k1 0x614A $k0',
	'sb $k1 0x61FD $k0',
	'sb $k1 0x622A $k0',
	'sb $k1 0x62DD $k0',
	'sb $k1 0x630A $k0',
	'sb $k1 0x63BD $k0',
	'sb $k1 0x63EA $k0',
	'lui $k0 0x8019', #Reduce greenshell hit height
	'lui $k1 0x3C01',
	'ori $K1 $K1 0x3DCC', #Here is where the actual height is set (Default 3FB9, 0x3DCC about 0.1)'
	'sw $k1 0xC56C $K0',
	'lui $K1 0x4481',
	'ori $k1 $K1 0x4000', 
	'sw $K1 0xC578 $k0',
	'lui $k0 0x802A',#Turn off item boxes, (credit hyperhacker: https://www.kodewerx.org/forum/viewtopic.php?f=18&t=2763#p46017)
	'lui $k1 0x080A',
	'addiu $k1 $k1 0x7561',
	'sw $k1 0xD830 $k0',
	'sw $zero 0xD834 $k0',


	#Flat battle courses
	'lui $k0 0x8010',
	'lb $k1 0x2116 $k0',
	'beq $k1 $zero 0x8', #If set to on
	'lui $k1 0x800E', #Flatten the battle field 810DC608 C0A0
	'lui $K0 0x3CCC', #Default = 3F80
	'sw $k0 0xC608 $k1',
	'lui $k0 0x802A',#Turn off item boxes, (credit hyperhacker: https://www.kodewerx.org/forum/viewtopic.php?f=18&t=2763#p46017)
	'lui $k1 0x080A',
	'addiu $k1 $k1 0x7561',
	'sw $k1 0xD830 $k0',
	'sw $zero 0xD834 $k0',	


	#Auto item
	'lui $k0 0x8010',
	'lb $k1 0x2117 $k0',
	'beq $k0 $zero 0x37', #If auto items are on
	'lb $k0 0x2115 $k0', #If inf. green shells are off, randomly assign items
 	'bne $k0 $zero 0x35',
# 	#Randomly assign item for P1
	'lui $k0 0x8016',
	'lui $k0 0x802C',#Load byte from RNG into $K0
	'lbu $k0 0xA290 $k0',
	'ori $k1 $zero 0xA1',
	'beq $k1 $k0 0x2', #If RNG value == something
	'addi $k1 $k1 0x1',
	'bne $k1 $k0 0x9', #If RNG value == something
	'lui $k0 0x8016',
	'lbu $k1 0x5F5F $k0',
	'bne $k1 $zero 0x2', #Check if player already has item, if not...
	'ori $k1 $zero 0x1',
	'sb $k1 0x5F5F $k0', #Randomly give player item
	'lbu $k1 0x611F $k0',
	'bne $k1 $zero 0x2', #Check if player already has item, if not...
	'ori $k1 $zero 0x1',
	'sb $k1 0x611F $k0', #Randomly give player item
# 	#Randomly assign item for P2
	'lui $k0 0x802C',#Load byte from RNG into $K0
	'lbu $k0 0xA290 $k0',
	'ori $k1 $zero 0xB1',
	'beq $k1 $k0 0x2', #If RNG value == something
	'addi $k1 $k1 0x1',
	'bne $k1 $k0 0x9', #If RNG value == something
	'lui $k0 0x8016',
	'lbu $k1 0x603F $k0',
	'bne $k1 $zero 0x2', #Check if player already has item, if not...
	'ori $k1 $zero 0x1',
	'sb $k1 0x603F $k0', #Randomly give player item
	'lbu $k1 0x61FF $k0',
	'bne $k1 $zero 0x2', #Check if player already has item, if not...
	'ori $k1 $zero 0x1',
	'sb $k1 0x61FF $k0', #Randomly give player item
# 	#Randomly assign item for P3
	'lui $k0 0x802C',#Load byte from RNG into $K0
	'lbu $k0 0xA290 $k0',
	'ori $k1 $zero 0xB2',
	'beq $k1 $k0 0x2', #If RNG value == something
	'addi $k1 $k1 0x1',
	'bne $k1 $k0 0x5', #If RNG value == something
	'lui $k0 0x8016',
	'lbu $k1 0x62DF $k0',
	'bne $k1 $zero 0x2', #Check if player already has item, if not...
	'ori $k1 $zero 0x1',
	'sb $k1 0x62DF $k0', #Randomly give player item
# 	#Randomly assign item for P4
	'lui $k0 0x802C',#Load byte from RNG into $K0
	'lbu $k0 0xA290 $k0',
	'ori $k1 $zero 0xB3',
	'beq $k1 $k0 0x2', #If RNG value == something
	'addi $k1 $k1 0x1',
	'bne $k1 $k0 0x5', #If RNG value == something
	'lui $k0 0x8016',
	'lbu $k1 0x63BF $k0',
	'bne $k1 $zero 0x2', #Check if player already has item, if not...
	'ori $k1 $zero 0x1',
	'sb $k1 0x63BF $k0', #Randomly give player item
]




crash_screen_gscode  = [
  '810045F0 0800', #Turn on build in crash screen to make debugging easier
  '810045F2 1192']
codeblock = codeblock + mk64_lib.gameshark_to_hex(crash_screen_gscode)


#Insert code block into rom
hook_addr = 0xD1DB8 #Hook into exception handler preamble
insert_code_here_addr = 0xE9E80 #PAL VI stuff?
#codeblock_addr = 0x58084  #somewhere in the debug
#mk64rom.insert_codeblock(hook_addr, codeblock_addr, codeblock)
mk64rom.insert_codeblock(hook_addr, insert_code_here_addr, codeblock)


#codeblock_addr = codeblock_addr + len(codeblock)*4+16

return_to_hook_address_2p =  hex(0x269C + mk64rom.rom_to_ram + 0x8)
return_to_hook_address_3p_4p =  hex(0x28F8 + mk64rom.rom_to_ram + 0x8)

display_code = [
	'addiu $SP $SP 0xFFEC', #Store registers
	'SW $A0 0x0000 $SP',
	'SW $A1 0x0004 $SP',
	'SW $A2 0x0008 $SP',
	'SW $A3 0x000C $SP',
	'SW $RA 0x0010 $SP',

	#If game is starting or restarting, force counter to starting value and ensure nobody is the hot potato
	'lui $a0 0x800F',
	'lbu $a1 0x6990 $a0',
	'ori $a2 $zero 0xE0',
	'bne $a1 $a2 0x12',
	'lui $a0 0x8010', #Reset HP back to max
	'lbu $a1 0x2000 $a0',
	'sb $a1 0x2001 $a0',
	'sb $a1 0x2002 $a0',
	'sb $a1 0x2003 $a0',
	'sb $a1 0x2004 $a0',
	'lui $a0 0x8010', #Set who is the hot potato back to nothing
	'sb $zero 0x2100 $a0',
	'lui $a0 0x8010',# #Activate music in 3P & 4P mode if it is set to on
	'lb $a0 0x2113 $a0',
	'beq $a0 $zero 0x7', #If set to on
	'lui $a0 0x8029',
	'lui $a1 0x240E',
	'ori $a1 $a1 0x0001',
	'sw $a1 0xEC9C $a0',
	'lui $a1 0x2409',
	'ori $a1 $a1 0x0001',
	'sw $a1 0xF9C4 $a0',

	#If nobody is the hot potato, reset timer to default value
	'lui $a0 0x8010',
	'lbu $a1 0x2100 $a0',
	'bne $a1 $zero 0x2',
	'lh $a1 0x2108 $a0',  #Reset timer to default value
	'sh $a1 0x2104 $a0',


	'lui $A1 0x800F', 	#Only run counter when not paused (game tempo is zero or less)
	'lbu $a1 0xA16C $a1',
	'bne $A1 $zero 0x41',
	'nop',

	'JAL 0x80057710', #Load font
	'nop',

	'lui $A2 0x800F', #text pointer = 800EF860
	'addiu $A2 $A2 0xB800',


	'lui $A0 0x8010', #Show custom timer at 0x80102104 (half)
	'lh $A3 0x2104 $A0',
	'lui $A1 0x8015', #Load game tempo to subtract from timer (to keep have timer keep seconds)
	'lw $A1 0x0114 $A1',
	'sub $a3 $a3 $a1', #Subtract game tempo
	'sh $a3 0x2104 $A0', #Store decremented timer back into ram slot
	'add $a3 $a3 $a1', #Add tempo back before displaying so countdown when paused shows the correct value
	'ori $A1 $zero 0x3C', #Divide timer by 60 (0x3C) so output display is in secconds
	'div $A3 $A1',
	'mflo $A3', #$A3 is the integer to display
	'ori $A0 $zero 0x28', #$A0 is the X pos
	'JAL 0x800577D0', #Run function to display int
	'ori $A1 $zero 0x60', #$A1 is the Y pos

	'lui $a0 0x8010', #Only display HP if starting HP > 1
	'lbu $a1 0x2000 $a0',
	'slti $a1 $a1 0x2',
	'bne $a1 $zero 0x2B',

	# #Display HP for P1
	'ori $A0 $zero 0x0', #$A0 is the X pos
	'ori $A1 $zero 0x0', #$A1 is the Y pos
	'lui $a3 0x8010',
	'lbu $a3 0x2001 $a3',
	'lui $A2 0x800F', #text pointer = 800EF810 for "HP", #Display HP P1
	'JAL 0x800577D0', #Run function to display int
	'addiu $A2 $A2 0xB810',

	# #Display HP for P2
	'ori $A0 $zero 0x0', #$A0 is the X pos
	'ori $A1 $zero 0x72', #$A1 is the Y pos
	'lui $a3 0x800E', #If number of players is not 2 at 0x800DC538 
	'lbu $a3 0xC53B $a3',
	'ori $a2 $zero 0x0002',
	'beq $a3 $a2 0x3',
	'nop',
	'ori $A0 $zero 0xF0', #$A0 is the X pos
	'ori $A1 $zero 0x0', #$A1 is the Y pos
	'lui $a3 0x8010',
	'lbu $a3 0x2002 $a3',
	'lui $A2 0x800F', #text pointer = 800EF810 for "HP", #Display HP P2
	'JAL 0x800577D0', #Run function to display int
	'addiu $A2 $A2 0xB810',

	# #Display HP for P3
	'lui $a3 0x800E', #If number of players is not 2 at 0x800DC538 
	'lbu $a3 0xC53B $a3',
	'ori $a2 $zero 0x0002',
	'beq $a3 $a2 0x7',
	'ori $A0 $zero 0x0', #$A0 is the X pos
	'ori $A1 $zero 0x72', #$A1 is the Y pos
	'lui $a3 0x8010',
	'lbu $a3 0x2003 $a3',
	'lui $A2 0x800F', #text pointer = 800EF810 for "HP", #Display HP P2
	'JAL 0x800577D0', #Run function to display int
	'addiu $A2 $A2 0xB810',

	# #Display HP for P4
	'lui $a3 0x800E', #If number of players is 4 at 0x800DC538 
	'lbu $a3 0xC53B $a3',
	'ori $a2 $zero 0x0004',
	'bne $a3 $a2 0x7',
	'ori $A0 $zero 0xF0', #$A0 is the X pos
	'ori $A1 $zero 0x72', #$A1 is the Y pos
	'lui $a3 0x8010',
	'lbu $a3 0x2004 $a3',
	'lui $A2 0x800F', #text pointer = 800EF810 for "HP", #Display HP P2
	'JAL 0x800577D0', #Run function to display int
	'addiu $A2 $A2 0xB810',

	'addiu $SP $SP 0x14', #Load registers no longer used
	'LW $A0 0x0000 $sp',
	'LW $A1 0x0004 $sp',
	'LW $RA 0x0010 $sp',
	'lui $a3 0x800E', #If number of players is 2 at 0x800DC538 
	'lbu $a3 0xC53B $a3',
	'ori $a2 $zero 0x0002',	
	'bne $a2 $a3 0x6',
	'LW $A2 0x0008 $sp', #Shove a load register into the delay slot here just to be efficient
	'LW $A3 0x000C $sp', #Ran last load register we need
	0x3C0B800E, #Replacement hook code
	0x8D6BC5E8,
	'J '+return_to_hook_address_2p,
	'nop',
	0x3C02800E, #Replacement hook code
	0x8C42C5E8,
	'J '+return_to_hook_address_3p_4p,
	'nop',

]


mk64rom.insert_code(codeblock_addr, display_code)


# hook_addr = 0x28E0 #Use Rena's hook for battle mode 3&4P
# replaced_hook_code = [0x3C0B800E, 0x956BC5B0]
hook_addr = 0x28F8
#Hook into 3&4P battle mode
code = ['j ' + hex(codeblock_addr+mk64rom.rom_to_ram), 'nop']
mk64rom.insert_code(hook_addr, code)



#replaced_hook_code = [0x3C02800E, 0x8C42C5E8]

#mk64rom.insert_codeblock(hook_addr, codeblock_addr , display_code + replaced_hook_code)
hook_addr = 0x269C #Use Rena's hook for battle mode 2P
#Hook into 2P battle mode
code = ['j ' + hex(codeblock_addr+mk64rom.rom_to_ram), 'nop']
mk64rom.insert_code(hook_addr, code)
#replaced_hook_code = [0x3C0B800E, 0x8D6BC5E8]
#mk64rom.insert_codeblock(hook_addr, codeblock_addr,  display_code + replaced_hook_code)

#codeblock_addr = codeblock_addr + len(display_code)*4 + 16
codeblock_addr = codeblock_addr + len(display_code)*4 + 8


menu_code = [
	#0x0C02555D,	#Run lines that were replaced by hook first
	#0x00000000,


	'addiu $SP $SP 0xFFDC', #Store registers
	'SW $A0 0x0000 $SP',
	'SW $A1 0x0004 $SP',
	'SW $A2 0x0008 $SP',
	'SW $A3 0x000C $SP',
	'SW $RA 0x0010 $SP',
	#'SW $T0 0x0014 $SP',
	#'#SW $T1 0x0018 $SP',
	#'SW $T2 0x0020 $SP',


	#Move menu selection y-axis or option based on P1 C-stick y-axis (Using c-stick activator #2 D014F0F3 00??)
	'lui $A0 0x8010',
	'lb $A1 0x210D $A0', #Load value of menu selection movmement in progress byte
	'lb $A3 0x210C $A0', #Load current menu selection
	'lui $A0 0x8015', #Load value of P1's joystick y-axis into $A0
	'lbu $A0 0xF0F3 $A0',
	'srl $A0 $A0 0x6', #Divide joystick value by 32
	#If menu selection in progress, skip moving the menu selection since it is already in the process of moving
	'bne $A1 $zero 0xA',
	#If c-stick is up and the value is high enough, move menu selection down
	'ori $A2 $zero 0x1',
	'bne $A0 $A2 0x3',
	'nop',
	'addi $A3 $A3 0xFFFF',
	'ori $A1 $zero 0x1', #Menu selection in progress byte set
	#if c-stick is down and the value is high enough, move menu selection up
	'ori $A2 $zero 0x2',
	'bne $A0 $A2 0x3',
	'nop',
	'addi $A3 $A3 0x1',
	'ori $A1 $zero 0x1', #Menu selection in progress byte set
	#Rest menu selection in progress byte if joystick is not moved far enough
	'beq $A0 $zero 0x3', #If joystick is up a little or...
	'ori $A2 $zero 0x3', #If joystick is down a little
	'bne $A0 $A2 0x2',
	'nop',
	'ori $A1 $zero 0x0',
	#if menu selection is too low, reset to min
	'addi $A2 $zero 0xFFFF',
	'bne $A3 $A2 0x2',
	'nop',
	'ori $A3 $zero 0x0',
	#If menu selection is too high, reset to max
	'ori $A2 $zero 0xB',  
	'bne $A3 $A2 0x2',
	'nop',
	'ori $A3 $zero 0xA',
	#Store menu selection in progress and menu selection bytes back to ram
	'lui $A0 0x8010', 
	'sb $A1 0x210D $A0',
	'sb $A3 0x210C $A0',


	#Move menu selection x-axis or option based on P1 C-stick x-axis (Using c-stick activator #2 D014F0F2 00??)
	'lb $A1 0x210E $A0', #Load value of menu selection movmement in progress byte
	#'lb $A3 0x210C $A0', #Load current menu selection
	'lui $A0 0x8015', #Load value of P1's joystick x-axis into $A0
	'lbu $A0 0xF0F2 $A0',
	'srl $A0 $A0 0x6', #Divide joystick value by 32
	#If menu selection in progress, skip moving the menu selection since it is already in the process of moving
	'ori $A2 $zero 0x4',
	'beq $A1 $A2 0x8',
	#If c-stick is left and the value is high enough, move menu selection left
	'ori $A2 $zero 0x1',
	'bne $A0 $A2 0x2',
	'nop',
	'ori $A1 $zero 0x1', #Menu selection in progress byte set
	#if c-stick is right and the value is high enough, move menu selection right
	'ori $A2 $zero 0x2',
	'bne $A0 $A2 0x2',
	'nop',
	'ori $A1 $zero 0x2', #Menu selection in progress byte set
	#Rest menu selection in progress byte if joystick is not moved far enough
	'beq $A0 $zero 0x5', #If joystick is up a little or...
	'ori $A2 $zero 0x3', #If joystick is down a little
	'beq $A0 $A2 0x3',
	'nop',
	'beq $zero $zero 0x2',
	'nop',
	'ori $A1 $zero 0x0',


	# #If menu selection is HP
	'bne $A3 $zero 0x16',
	'lui $A2 0x8010', #Load max HP
	'lb $A0 0x2000 $A2',
	'ori $A2 $zero 0x2', #If joystick was left
	'bne $A1 $A2 0x3',
	'nop',
	'addi $A0 $A0 0xFFFF', #Subtract 1 HP
	'ori $A1 $zero 0x4', #Set menu selection in progress byte to state indicating the selection has finished
	'ori $A2 $zero 0x1', #If joystick was right
	'bne $A1 $A2 0x3',
	'nop',
	'addi $A0 $A0 0x1', #Add 1 HP
	'ori $A1 $zero 0x4', #Set menu selection in progress byte to state indicating the selection has finished
	#if HP too low, reset to min
	'addi $A2 $zero 0x0',
	'bne $A0 $A2 0x2',
	'nop',
	'ori $A0 $zero 0x1',
	#If HPis too high, reset to max
	'ori $A2 $zero 0x64',  
	'bne $A0 $A2 0x2',
	'nop',
	'ori $A0 $zero 0x63',
	'lui $A2 0x8010', #Store updated max HP
	'sb $A0 0x2000 $A2',




	#If menu selection is Countdown
	'ori $A2 $zero 0x1',
	'bne $A3 $A2 0x12',
	'lui $A2 0x8010', #Load countdown timer default
	'lh $A0 0x2108 $A2',
	'ori $A2 $zero 0x2', #If joystick was left
	'bne $A1 $A2 0x3',
	'nop',
	'addi $A0 $A0 0xFED4', #Subtract 5 seconds
	'ori $A1 $zero 0x4', #Set menu selection in progress byte to state indicating the selection has finished
	'ori $A2 $zero 0x1', #If joystick was right
	'bne $A1 $A2 0x3',
	'nop',
	'addi $A0 $A0 0x12C', #Add 5 seconds
	'ori $A1 $zero 0x4', #Set menu selection in progress byte to state indicating the selection has finished
	#if countdown default too low, reset to min
	'slti $A2 $A0 0x0000',
	'beq $a2 $zero 0x2',
	'nop',
	'ori $A0 $zero 0x0',
	'lui $A2 0x8010', #Store updated countdown timer default
	'sh $A0 0x2108 $A2',


	#If menu selection is Star Items on/off
	'ori $A2 $zero 0x2',
	'bne $A3 $A2 0xD',
	'lui $A2 0x8010', #Load item status
	'lb $A0 0x210F $A2',
	'ori $A2 $zero 0x1', #If joystick was right
	'beq $A1 $A2 0x5',
	'ori $A2 $zero 0x2', #If joystick was left
	'beq $A1 $A2 0x3',
	'nop',
	'beq $zero $zero 0x5', #If joystick was something else, just skip the rest of the code
	'nop',
	'ori $A1 $zero 0x4', #Set menu selection in progress byte to state indicating the selection has finished
	'nor $A0 $A0 $zero', #Not instruction to flip the bit in $A0
	'lui $A2 0x8010', #Store updated item status
	'sb $A0 0x210F $A2',

	#If menu selection is Ghost Items on/off
	'ori $A2 $zero 0x3',
	'bne $A3 $A2 0xD',
	'lui $A2 0x8010', #Load item status
	'lb $A0 0x2110 $A2',
	'ori $A2 $zero 0x1', #If joystick was right
	'beq $A1 $A2 0x5',
	'ori $A2 $zero 0x2', #If joystick was left
	'beq $A1 $A2 0x3',
	'nop',
	'beq $zero $zero 0x5', #If joystick was something else, just skip the rest of the code
	'nop',
	'ori $A1 $zero 0x4', #Set menu selection in progress byte to state indicating the selection has finished
	'nor $A0 $A0 $zero', #Not instruction to flip the bit in $A0
	'lui $A2 0x8010', #Store updated item status
	'sb $A0 0x2110 $A2',


	#If menu selection is Infinite green shells
	'ori $A2 $zero 0x4',
	'bne $A3 $A2 0xD',
	'lui $A2 0x8010', #Load status
	'lb $A0 0x2115 $A2',
	'ori $A2 $zero 0x1', #If joystick was right
	'beq $A1 $A2 0x5',
	'ori $A2 $zero 0x2', #If joystick was left
	'beq $A1 $A2 0x3',
	'nop',
	'beq $zero $zero 0x5', #If joystick was something else, just skip the rest of the code
	'nop',
	'ori $A1 $zero 0x4', #Set menu selection in progress byte to state indicating the selection has finished
	'nor $A0 $A0 $zero', #Not instruction to flip the bit in $A0
	'lui $A2 0x8010', #Store updated item status
	'sb $A0 0x2115 $A2',


	#If menu selection is flat coureses
	'ori $A2 $zero 0x5',
	'bne $A3 $A2 0xD',
	'lui $A2 0x8010', #Load status
	'lb $A0 0x2116 $A2',
	'ori $A2 $zero 0x1', #If joystick was right
	'beq $A1 $A2 0x5',
	'ori $A2 $zero 0x2', #If joystick was left
	'beq $A1 $A2 0x3',
	'nop',
	'beq $zero $zero 0x5', #If joystick was something else, just skip the rest of the code
	'nop',
	'ori $A1 $zero 0x4', #Set menu selection in progress byte to state indicating the selection has finished
	'nor $A0 $A0 $zero', #Not instruction to flip the bit in $A0
	'lui $A2 0x8010', #Store updated item status
	'sb $A0 0x2116 $A2',


	#If menu selection is auto items
	'ori $A2 $zero 0x6',
	'bne $A3 $A2 0xD',
	'lui $A2 0x8010', #Load status
	'lb $A0 0x2117 $A2',
	'ori $A2 $zero 0x1', #If joystick was right
	'beq $A1 $A2 0x5',
	'ori $A2 $zero 0x2', #If joystick was left
	'beq $A1 $A2 0x3',
	'nop',
	'beq $zero $zero 0x5', #If joystick was something else, just skip the rest of the code
	'nop',
	'ori $A1 $zero 0x4', #Set menu selection in progress byte to state indicating the selection has finished
	'nor $A0 $A0 $zero', #Not instruction to flip the bit in $A0
	'lui $A2 0x8010', #Store updated item status
	'sb $A0 0x2117 $A2',

	#If menu selection is Widescreen on/off
	'ori $A2 $zero 0x7',
	'bne $A3 $A2 0xD',
	'lui $A2 0x8010', #Load status
	'lb $A0 0x2111 $A2',
	'ori $A2 $zero 0x1', #If joystick was right
	'beq $A1 $A2 0x5',
	'ori $A2 $zero 0x2', #If joystick was left
	'beq $A1 $A2 0x3',
	'nop',
	'beq $zero $zero 0x5', #If joystick was something else, just skip the rest of the code
	'nop',
	'ori $A1 $zero 0x4', #Set menu selection in progress byte to state indicating the selection has finished
	'nor $A0 $A0 $zero', #Not instruction to flip the bit in $A0
	'lui $A2 0x8010', #Store updated item status
	'sb $A0 0x2111 $A2',


	#If menu selection is antialiasing on/off
	'ori $A2 $zero 0x8',
	'bne $A3 $A2 0xD',
	'lui $A2 0x8010', #Load status
	'lb $A0 0x2112 $A2',
	'ori $A2 $zero 0x1', #If joystick was right
	'beq $A1 $A2 0x5',
	'ori $A2 $zero 0x2', #If joystick was left
	'beq $A1 $A2 0x3',
	'nop',
	'beq $zero $zero 0x5', #If joystick was something else, just skip the rest of the code
	'nop',
	'ori $A1 $zero 0x4', #Set menu selection in progress byte to state indicating the selection has finished
	'nor $A0 $A0 $zero', #Not instruction to flip the bit in $A0
	'lui $A2 0x8010', #Store updated item status
	'sb $A0 0x2112 $A2',

	#If menu selection is 3P/4P music on/off
	'ori $A2 $zero 0x9',
	'bne $A3 $A2 0xD',
	'lui $A2 0x8010', #Load status
	'lb $A0 0x2113 $A2',
	'ori $A2 $zero 0x1', #If joystick was right
	'beq $A1 $A2 0x5',
	'ori $A2 $zero 0x2', #If joystick was left
	'beq $A1 $A2 0x3',
	'nop',
	'beq $zero $zero 0x5', #If joystick was something else, just skip the rest of the code
	'nop',
	'ori $A1 $zero 0x4', #Set menu selection in progress byte to state indicating the selection has finished
	'nor $A0 $A0 $zero', #Not instruction to flip the bit in $A0
	'lui $A2 0x8010', #Store updated item status
	'sb $A0 0x2113 $A2',

	#If menu selection is all chars select on/off
	'ori $A2 $zero 0xA',
	'bne $A3 $A2 0xD',
	'lui $A2 0x8010', #Load status
	'lb $A0 0x2114 $A2',
	'ori $A2 $zero 0x1', #If joystick was right
	'beq $A1 $A2 0x5',
	'ori $A2 $zero 0x2', #If joystick was left
	'beq $A1 $A2 0x3',
	'nop',
	'beq $zero $zero 0x5', #If joystick was something else, just skip the rest of the code
	'nop',
	'ori $A1 $zero 0x4', #Set menu selection in progress byte to state indicating the selection has finished
	'nor $A0 $A0 $zero', #Not instruction to flip the bit in $A0
	'lui $A2 0x8010', #Store updated item status
	'sb $A0 0x2114 $A2',




	'lui $A2 0x8010',
	'sb $A1 0x210E $A2',	#Store menu selection in progress byte back to ram


	 
	#'lui $a1 0x8019', #Stop title demo counter at 8018EE00 from counting anything
	#'sw $zero 0xEE00 $a1',


	'JAL 0x80057710', #Load font
	'nop',

	#'JAL 0x800930D8',#Set text color
	#'ori $A0 $zero 0x00',# A0=color (00=blue 01=green 02=red 03=yellow 04=cool transition through them, 05=same transition, 06+=glitches)'

	# Display hack title "HOT POTATO BATTLE"
	'ori $A0 $zero 0x48', #$A0 is the X pos
	'ori $A1 $zero 0x00', #A1 is the y pos
	'lui $A2 0x800F', #text pointer
	'JAL 0x800577A4', #Print text
	'addiu $A2 $A2 0xB848',

	#Display hack title info "VX.X BY TRICLON"
	'ori $A0 $zero 0x50', #$A0 is the X pos
	'ori $A1 $zero 0xC', #A1 is the y pos
	'lui $A2 0x800F', #text pointer
	'JAL 0x800577A4', #Print text
	'addiu $A2 $A2 0xB85A',


	# #Display "===" showing current menu selection

	# 'addi $A3 $A1 0x70',
	'ori $A0 $zero 0x28', #$A0 is the X pos
	'lui $A1 0x8010', #Load current menu selection and set the Y position based on that, $A1 is the y position
	'lb $A1 0x210C $A1',
	'ori $a2 $zero 0xC', #Multiply $A1 by 12
	'mult $A1 $A2',
	'mflo $A1',
	'addi $A1 $A1 0x30', #A1 is the y pos
	'lui $A2 0x800F', #text pointer
	'JAL 0x800577A4', #Print text
	'addiu $A2 $A2 0xB820',
	'ori $A0 $zero 0xD8', #$A0 is the X pos
	'lui $A1 0x8010', #Load current menu selection and set the Y position based on that, $A1 is the y position
	'lb $A1 0x210C $A1',
	'ori $a2 $zero 0xC', #Multiply $A1 by 12
	'mult $A1 $A2',
	'mflo $A1',
	'addi $A1 $A1 0x30', #A1 is the y pos
	'lui $A2 0x800F', #text pointer
	'JAL 0x800577A4', #Print text
	'addiu $A2 $A2 0xB820',


	'lui $A3 0x8010', #Load max HP from 0x80102000
	'lbu $A3 0x2000 $A3',
	'lui $A2 0x800F', #text pointer = 800EF810 for "HP", #Display HP P1
	'addiu $A2 $A2 0xB810',
	'ori $A0 $zero 0x76', #$A0 is the X pos
	'JAL 0x800577D0', #Run function to display int
	'ori $A1 $zero 0x30', #$A1 is the Y pos

	'lui $A3 0x8010', #Load default countdown from 0x80102108
	'lhu $A3 0x2108 $A3',
	'ori $A1 $zero 0x3C', #Divide timer by 60 (0x3C) so output display is in secconds
	'div $A3 $A1',
	'mflo $A3', #$A3 is the integer to display
	'lui $A2 0x800F', #text pointer = 800EF800 for "COUNTDOWN"
	'addiu $A2 $A2 0xB814',
	'ori $A0 $zero 0x5D', #$A0 is the X pos
	'JAL 0x800577D0', #Run function to display int
	'ori $A1 $zero 0x3A', #$A1 is the Y pos

	# #Display "STAR ITEMS"
	'lui $A2 0x800F', #text pointer = 800EFF24 for "STAR & GHOST ITEMS"
	'addiu $A2 $A2 0xB824',
	'ori $A0 $zero 0x48', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0x48', #$A1 is the Y pos
	'lui $A2 0x800F', #text pointer for "OFF"
	'addiu $A2 $A2 0xB840',
	'lui $A0 0x8010', #Load item status
	'lb $A0 0x210F $A0',
	'bne $A0 $zero 0x2', #Move pointer to "ON if the item status = 0"
	'nop',
	'addi $A2 $A2 0x4',
	'ori $A0 $zero 0xB8', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0x48', #$A1 is the Y pos


	# #Overwrite stars if they are turned off
	'lui $A2 0x8010', #Load item status
	'lb $A2 0x210F $A2',
	'beq $A2 $zero 0x13', #If stars are turned off
	'ori $A0 $zero 0x01',
	'lui $A1 0x801B',
	'sb $A0 0x849F $A1',
	'lui $A0 0x0203',
	'addiu $A0 $A0 0x0405',
	'sw $A0 0x84A0 $A1',
	'lui $A0 0x0102',
	'addiu $A0 $A0 0x0304',
	'sw $A0 0x84A4 $A1',
	'lui $A0 0x0501',
	'addiu $A0 $A0 0x0203',
	'sw $A0 0x84A8 $A1',
	'lui $A0 0x0405',
	'addiu $A0 $A0 0x0102',
	'sw $A0 0x84AC $A1',
	'ori $A0 $zero 0x0304',
	'sh $A0 0x84B0 $A1',
	'ori $A0 $zero 0x05',
	'sb $A0 0x84B2 $A1',
	'bne $A2 $zero 0xD', #If stars are turned on
	'ori $A0 $zero 0x0A',
	'lui $A1 0x801B',
	'sb $A0 0x849F $A1',
	'lui $A0 0x0A0A',
	'addiu $A0 $A0 0x0A0A',
	'sw $A0 0x84A0 $A1',
	'sw $A0 0x84A4 $A1',
	'sw $A0 0x84A8 $A1',
	'sw $A0 0x84AC $A1',
	'ori $A0 $zero 0x0A0A',
	'sh $A0 0x84B0 $A1',
	'ori $A0 $zero 0x0A',
	'sb $A0 0x84B2 $A1',


	# #Display "GHOST ITEMS"
	'lui $A2 0x800F', #text pointer for  "GHOST ITEMS"
	'addiu $A2 $A2 0xB830',
	'ori $A0 $zero 0x48', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0x54', #$A1 is the Y pos
	'lui $A2 0x800F', #text pointer for "OFF"
	'addiu $A2 $A2 0xB840',
	'lui $A0 0x8010', #Load item status
	'lb $A0 0x2110 $A0',
	'bne $A0 $zero 0x2', #Move pointer to "ON if the item status = 0"
	'nop',
	'addi $A2 $A2 0x4',
	'ori $A0 $zero 0xB8', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0x54', #$A1 is the Y pos


	# #Overwrite ghosts if they are turned off
	'lui $A2 0x8010', #Load item status
	'lb $A2 0x2110 $A2',
	'beq $A2 $zero 0x6', #If ghosts are turned off
	'ori $A0 $zero 0x01',
	'lui $A1 0x801B',
	'sb $A0 0x84B3 $A1',
	'lui $A0 0x0203',
	'addiu $A0 $A0 0x0405',
	'sw $A0 0x84B4 $A1',
	'bne $A2 $zero 0x6', #If ghosts are turned on
	'ori $A0 $zero 0x0B',
	'lui $A1 0x801B',
	'sb $A0 0x84B3 $A1',
	'lui $A0 0x0B0B',
	'addiu $A0 $A0 0x0B0B',
	'sw $A0 0x84B4 $A1',





	#DISPLAY "INF. G. SHELLS"
	'lui $A2 0x800F', #text pointer
	'addiu $A2 $A2 0xB8A4',
	'ori $A0 $zero 0x48', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0x60', #$A1 is the Y pos
	'lui $A2 0x800F', #text pointer for "OFF"
	'addiu $A2 $A2 0xB840',
	'lui $A0 0x8010', #Load status
	'lb $A0 0x2115 $A0',
	'beq $A0 $zero 0x2', #Move pointer to "ON if the item status = 0"
	'nop',
	'addi $A2 $A2 0x4',
	'ori $A0 $zero 0xB8', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0x60', #$A1 is the Y pos

	#Restore shell hit height if infinite green shells are turned back off
	'lui $A0 0x8010', #Load status
	'lb $A0 0x2115 $A0',
	'bne $A0 $zero 0x4',#if infinite green shells are turned back off
	'lui $a0 0x8019', #Restore greenshell hit height
	'lui $a1 0x3C01',
	'ori $a1 $a1 0x3FB9', #Here is where the actual height is set (Default 3FB9, 0x3DCC about 0.1)'
	'sw $a1 0xC56C $a0',


	#DISPLAY "FLAT COURSES"
	'lui $A2 0x800F', #text pointer
	'addiu $A2 $A2 0xB8B4',
	'ori $A0 $zero 0x48', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0x6C', #$A1 is the Y pos
	'lui $A2 0x800F', #text pointer for "OFF"
	'addiu $A2 $A2 0xB840',
	'lui $A0 0x8010', #Load status
	'lb $A0 0x2116 $A0',
	'beq $A0 $zero 0x2', #Move pointer to "ON if the item status = 0"
	'nop',
	'addi $A2 $A2 0x4',
	'ori $A0 $zero 0xB8', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0x6C', #$A1 is the Y pos

	#Restore regular course scaling if flat courses are turned back off
	'lui $A0 0x8010', #Load status
	'lb $A0 0x2116 $A0',
	'bne $A0 $zero 0x3',#if turned off	
	'lui $a1 0x800E', #Flatten the battle field 810DC608 C0A0
	'lui $a0 0x3F80', #Default = 3F80
	'sw $a0 0xC608 $a1',

	#DISPLAY "AUTO-ITEMS"
	'lui $A2 0x800F', #text pointer
	'addiu $A2 $A2 0xB8C4',
	'ori $A0 $zero 0x48', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0x78', #$A1 is the Y pos
	'lui $A2 0x800F', #text pointer for "OFF"
	'addiu $A2 $A2 0xB840',
	'lui $A0 0x8010', #Load status
	'lb $A0 0x2117 $A0',
	'beq $A0 $zero 0x2', #Move pointer to "ON if the item status = 0"
	'nop',
	'addi $A2 $A2 0x4',
	'ori $A0 $zero 0xB8', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0x78', #$A1 is the Y pos


	# #Display "WIDESCREEN"
	'lui $A2 0x800F', #text pointer for  "WIDESCREEN"
	'addiu $A2 $A2 0xB86C',
	'ori $A0 $zero 0x48', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0x84', #$A1 is the Y pos
	'lui $A2 0x800F', #text pointer for "OFF"
	'addiu $A2 $A2 0xB840',
	'lui $A0 0x8010', #Load status
	'lb $A0 0x2111 $A0',
	'beq $A0 $zero 0x2', #Move pointer to "ON if the item status = 0"
	'nop',
	'addi $A2 $A2 0x4',
	'ori $A0 $zero 0xB8', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0x84', #$A1 is the Y pos


	# #Display "ANTIALIASING"
	'lui $A2 0x800F', #text pointer for  "ANTIALIASING"
	'addiu $A2 $A2 0xB878',
	'ori $A0 $zero 0x48', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0x90', #$A1 is the Y pos
	'lui $A2 0x800F', #text pointer for "OFF"
	'addiu $A2 $A2 0xB840',
	'lui $A0 0x8010', #Load status
	'lb $A0 0x2112 $A0',
	'beq $A0 $zero 0x2', #Move pointer to "ON if the item status = 0"
	'nop',
	'addi $A2 $A2 0x4',
	'ori $A0 $zero 0xB8', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0x90', #$A1 is the Y pos


	#Display "3P/4P MUSIC"
	'lui $A2 0x800F', #text pointer for  "3P/4P MUSIC"
	'addiu $A2 $A2 0xB888',
	'ori $A0 $zero 0x48', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0x9C', #$A1 is the Y pos
	'lui $A2 0x800F', #text pointer for "OFF"
	'addiu $A2 $A2 0xB840',
	'lui $A0 0x8010', #Load status
	'lb $A0 0x2113 $A0',
	'beq $A0 $zero 0x2', #Move pointer to "ON if the item status = 0"
	'nop',
	'addi $A2 $A2 0x4',
	'ori $A0 $zero 0xB8', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0x9C', #$A1 is the Y pos


	#Display "SAME CHARS"
	'lui $A2 0x800F', #text pointer for  "SAME CHARS"
	'addiu $A2 $A2 0xB894',
	'ori $A0 $zero 0x48', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0xA8', #$A1 is the Y pos
	'lui $A2 0x800F', #text pointer for "OFF"
	'addiu $A2 $A2 0xB840',
	'lui $A0 0x8010', #Load status
	'lb $A0 0x2114 $A0',
	'beq $A0 $zero 0x2', #Move pointer to "ON if the item status = 0"
	'nop',
	'addi $A2 $A2 0x4',
	'ori $A0 $zero 0xB8', #$A0 is the X pos
	'JAL 0x800577A4', #Run function to display text
	'ori $A1 $zero 0xA8', #$A1 is the Y pos


	'addiu $SP $SP 0x24', #Load registers
	'LW $A0 0x0000 $sp',
	'LW $A1 0x0004 $sp',
	'LW $A2 0x0008 $sp',
	'LW $A3 0x000C $sp',
	'LW $RA 0x0010 $sp',
	#'LW $T0 0x0014 $SP',
	#'LW $T1 0x0018 $SP',
	#'LW $T2 0x0020 $SP',
	]



hook_addr = 0x957D0 #Title screen hook
replaced_hook_code = []
mk64rom.insert_codeblock(hook_addr, codeblock_addr,  menu_code + replaced_hook_code)

codeblock_addr = codeblock_addr + len(menu_code)*4 + 16



#Hide balloons in battle mode
nop = ['nop']
#mk64rom.insert_code(0x0006C408, nop) #Show one ballooon to make it easy to see each player
mk64rom.insert_code(0x0006C42C, nop) #But hide the left and right balloons
mk64rom.insert_code(0x0006C450, nop)

#Set lighting effect time to very short because lighting effect is used to indicate HP loss, and we don't actually want to shrink anyone
mk64rom.insert_code(0x8EF00, [0x28410040])



#Save rom
mk64rom.save(output_file)